#ifndef REREFONS_H
#define REREFONS_H

#include <QObject>
#include <QMqttClient>

#define MQTT_BROKER "test.mosquitto.org"
#define MQTT_PORT 1883

#define TEMA_T1 "/dam/mesura/T1JB"
#define TEMA_T3 "/dam/mesura/T3JB"
#define TEMA_CABAL "/dam/mesura/cabalJB"

class RereFons : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString szCadena READ szCadena WRITE setCadena NOTIFY cadenaCanviada)
    Q_PROPERTY(int  nCmpt READ nCmpt WRITE setCmpt NOTIFY cmptChanged)
    Q_PROPERTY(int  nSlider READ nSlider WRITE setSlider NOTIFY sliderChanged)

public:
    explicit RereFons(QObject *parent = nullptr);
    QString szCadena();
    void setCadena(const QString &szValue);
    int nCmpt();
    void setCmpt(const int &nC);
    int nSlider();
    void setSlider(const int &nC);
    void subscription(QString topic);

signals:
    void cadenaCanviada();
    void cmptChanged();
    void sliderChanged();

private:
    QString m_szCadena;
    int m_nCmpt,m_nSlider;

    QMqttClient *m_client;
    void vGestionaResposta(QString tema,QString missatge);
    void publica(QString tema,QString missatge);

    bool bMqttConnectat;

public slots:
    void vActualitza();

private slots:
    void updateLogStateChange();
    void brokerDisconnected();
};

#endif // REREFONS_H
